//**************************************************************//
//  Effect File exported by RenderMonkey 1.6
//
//  - Although many improvements were made to RenderMonkey FX  
//    file export, there are still situations that may cause   
//    compilation problems once the file is exported, such as  
//    occasional naming conflicts for methods, since FX format 
//    does not support any notions of name spaces. You need to 
//    try to create workspaces in such a way as to minimize    
//    potential naming conflicts on export.                    
//    
//  - Note that to minimize resulting name collisions in the FX 
//    file, RenderMonkey will mangle names for passes, shaders  
//    and function names as necessary to reduce name conflicts. 
//**************************************************************//

//--------------------------------------------------------------//
// HLSL
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// TexturedPhong
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string HLSL_TexturedPhong_Pass_0_Model : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\Torus.3ds";

float4x4 matWorld : World;
float4x4 matWorldViewProjection : WorldViewProjection;

struct VS_INPUT 
{
   float4 Position : POSITION0;
   float2 Texcoord : TEXCOORD0;
   float3 Normal :   NORMAL0;
   
};

struct VS_OUTPUT 
{
   float4 Position :        POSITION0;
   float2 Texcoord :        TEXCOORD0;
   float3 Normal   :        TEXCOORD1;   
   float3 View     :        TEXCOORD2;      
};

VS_OUTPUT HLSL_TexturedPhong_Pass_0_Vertex_Shader_vs_main( VS_INPUT Input )
{
   VS_OUTPUT Output = (VS_OUTPUT) 0;

   // Output: Transformed Position
   Output.Position = mul(Input.Position, matWorldViewProjection);
   
   // Transform input normal to world space
   Output.Normal = normalize( mul( Input.Normal, matWorld ) ); 
   
      // Compute positions in world space
   Output.View =  mul (Input.Position, matWorld);
   
   // Output: Texture Coords
   Output.Texcoord = Input.Texcoord;
      
   return( Output );
   
}



float4 fvLightPosition
<
   string UIName = "fvLightPosition";
   string UIWidget = "Direction";
   bool UIVisible =  false;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 0.00, 0.00, 100.00, 1.00 );
float4 fvViewPosition : ViewPosition;
float4 fvAmbient
<
   string UIName = "fvAmbient";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.37, 0.37, 0.37, 0.00 );
float4 fvDiffuse
<
   string UIName = "fvDiffuse";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.63, 0.63, 0.63, 0.00 );
float4 fvSpecular
<
   string UIName = "fvSpecular";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.97, 1.00, 0.73, 0.43 );
float4 fvMaterial
<
   string UIName = "fvMaterial";
   string UIWidget = "Direction";
   bool UIVisible =  false;
   float4 UIMin = float4( 0.00, 0.00, 0.00, 0.00 );
   float4 UIMax = float4( 1.00, 1.00, 1.00, 1.00 );
   bool Normalize =  false;
> = float4( 1.00, 0.50, 0.80, 10.00 );
float fblend
<
   string UIName = "fblend";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
> = float( 1.00 );
texture base_Tex
<
   string ResourceName = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Textures\\Fieldstone.tga";
>;
sampler2D baseMap = sampler_state
{
   Texture = (base_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   MINFILTER = LINEAR;
   MAGFILTER = LINEAR;
   MIPFILTER = LINEAR;
};


struct PS_INPUT 
{   
   float2 Texcoord :        TEXCOORD0;
   float3 Normal   :        TEXCOORD1;         
   float3 View     :        TEXCOORD2;      
};

float4 HLSL_TexturedPhong_Pass_0_Pixel_Shader_ps_main( PS_INPUT Input ) : COLOR0
{     
   //1. Ambient Term
   float4 ambient = fvAmbient * fvMaterial.x;
   
   //2. Diffuse Term
   float3 L = normalize(fvLightPosition - Input.View);   
   float4 diffuse = fvDiffuse * fvMaterial.y * max(0, dot(Input.Normal, L));
   
   //3. Specular Term
   float3 V = normalize(fvViewPosition - Input.View);
   float3 H = normalize(L + V);
   float4 specular = fvSpecular * fvMaterial.z * pow(max(dot(Input.Normal,H),0),fvMaterial.w);      
   
   float4 Final = saturate(tex2D(baseMap, Input.Texcoord) * (ambient+diffuse) + specular);
   
   return fblend * Final;   
}



//--------------------------------------------------------------//
// ShadowMapping
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string HLSL_ShadowMapping_Pass_0_Model : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\Torus.3ds";

texture ShadowMap_Tex : RenderColorTarget
<
   float2 RenderTargetDimensions = {512,512};
   string Format="D3DFMT_R32F";
   float  ClearDepth=1.000000;
   int    ClearColor=0;
>;
float4x4 matLightViewProjection
<
   string UIName = "matLightViewProjection";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
> = float4x4( 1.20, 0.00, 0.00, 0.00, 0.00, 2.41, 0.00, 36.21, 0.00, 0.00, 1.00, 149.15, 0.00, 0.00, 1.00, 150.00 );

struct HLSL_ShadowMapping_Pass_0_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
};

struct HLSL_ShadowMapping_Pass_0_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;  
   float2 Depth    : TEXCOORD0;   
};

HLSL_ShadowMapping_Pass_0_Vertex_Shader_VS_OUTPUT HLSL_ShadowMapping_Pass_0_Vertex_Shader_vs_main( HLSL_ShadowMapping_Pass_0_Vertex_Shader_VS_INPUT Input )
{
   HLSL_ShadowMapping_Pass_0_Vertex_Shader_VS_OUTPUT Output;
   
   Output.Position = mul(Input.Position, matLightViewProjection);  
      
   Output.Depth.xy = Output.Position.zw;   
   
   return( Output );   
}




float4 HLSL_ShadowMapping_Pass_0_Pixel_Shader_ps_main(float2 Depth: TEXCOORD0) : COLOR
{        
      return Depth.x / Depth.y;
}




//--------------------------------------------------------------//
// Pass 1
//--------------------------------------------------------------//
string HLSL_ShadowMapping_Pass_1_Model : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\Torus.3ds";

float4x4 HLSL_ShadowMapping_Pass_1_Vertex_Shader_matLightViewProjection
<
   string UIName = "HLSL_ShadowMapping_Pass_1_Vertex_Shader_matLightViewProjection";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
> = float4x4( 1.20, 0.00, 0.00, 0.00, 0.00, 2.41, 0.00, 36.21, 0.00, 0.00, 1.00, 149.15, 0.00, 0.00, 1.00, 150.00 );
float4x4 HLSL_ShadowMapping_Pass_1_Vertex_Shader_matWorld : World;
float4x4 HLSL_ShadowMapping_Pass_1_Vertex_Shader_matWorldViewProjection : WorldViewProjection;

struct HLSL_ShadowMapping_Pass_1_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   float2 Texcoord : TEXCOORD0;
   float3 Normal :   NORMAL0;
   
};

struct HLSL_ShadowMapping_Pass_1_Vertex_Shader_VS_OUTPUT 
{
   float4 Position  :        POSITION0;
   float2 Texcoord  :        TEXCOORD0;
   float3 Normal    :        TEXCOORD1;         
   float3 View      :        TEXCOORD2;  
   float4 VPosLight :        TEXCOORD3;
   float4 UPosLight :        TEXCOORD4;  
};

HLSL_ShadowMapping_Pass_1_Vertex_Shader_VS_OUTPUT HLSL_ShadowMapping_Pass_1_Vertex_Shader_vs_main( HLSL_ShadowMapping_Pass_1_Vertex_Shader_VS_INPUT Input )
{
   HLSL_ShadowMapping_Pass_1_Vertex_Shader_VS_OUTPUT Output = (HLSL_ShadowMapping_Pass_1_Vertex_Shader_VS_OUTPUT) 0;
   
    // Output: Transformed Position
   Output.Position = mul(Input.Position, HLSL_ShadowMapping_Pass_1_Vertex_Shader_matWorldViewProjection);
   
   // Transform input normal to world space
   Output.Normal = normalize( mul( Input.Normal, HLSL_ShadowMapping_Pass_1_Vertex_Shader_matWorld ) ); 
   
      // Compute positions in world space
   Output.View =  mul (Input.Position, HLSL_ShadowMapping_Pass_1_Vertex_Shader_matWorld);
   
   // Output: Texture Coords
   Output.Texcoord = Input.Texcoord;   
   
   // Calculate LightProjection
   // Matrix to transform from object space to light space
   float4 temp = mul(Input.Position, HLSL_ShadowMapping_Pass_1_Vertex_Shader_matWorld);
   Output.VPosLight = mul(temp, HLSL_ShadowMapping_Pass_1_Vertex_Shader_matLightViewProjection);        
   Output.UPosLight.xyz = Output.VPosLight.xyz * float3(0.5f,-0.5f,0.5f) + Output.VPosLight.w * 0.5f;
   Output.UPosLight.w = Output.VPosLight.w;
   return( Output );
   
}



float4 HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvAmbient
<
   string UIName = "HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvAmbient";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.62, 0.62, 0.62, 0.00 );
float4 HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvDiffuse
<
   string UIName = "HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvDiffuse";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.73, 0.73, 0.73, 0.00 );
float4 HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvSpecular
<
   string UIName = "HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvSpecular";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.97, 1.00, 0.73, 0.00 );
float4 HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvMaterial
<
   string UIName = "HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvMaterial";
   string UIWidget = "Direction";
   bool UIVisible =  false;
   float4 UIMin = float4( 0.00, 0.00, 0.00, 0.00 );
   float4 UIMax = float4( 1.00, 1.00, 1.00, 1.00 );
   bool Normalize =  false;
> = float4( 0.57, 0.90, 0.55, 1.96 );
float HLSL_ShadowMapping_Pass_1_Pixel_Shader_fblend
<
   string UIName = "HLSL_ShadowMapping_Pass_1_Pixel_Shader_fblend";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
> = float( 1.00 );
sampler2D HLSL_ShadowMapping_Pass_1_Pixel_Shader_baseMap = sampler_state
{
   Texture = (base_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   MINFILTER = LINEAR;
   MAGFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
sampler ShadowMap = sampler_state
{
   Texture = (ShadowMap_Tex);
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
   MINFILTER = POINT;
   MIPFILTER = POINT;
   MAGFILTER = POINT;
};
float4 HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvLightPosition
<
   string UIName = "HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvLightPosition";
   string UIWidget = "Direction";
   bool UIVisible =  true;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 0.00, 0.00, -150.00, 1.00 );
float4 HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvViewPosition : ViewPosition;
float fvBias
<
   string UIName = "fvBias";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 0.01;
> = float( 0.00 );
float fvSize
<
   string UIName = "fvSize";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = -1.00;
   float UIMax = 0.00;
> = float( 512.00 );
float fvOffset
<
   string UIName = "fvOffset";
   string UIWidget = "Numeric";
   bool UIVisible =  false;
   float UIMin = -1.00;
   float UIMax = 1.00;
> = float( 0.00 );
bool bvShadow
<
   string UIName = "bvShadow";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
> = bool( true );
float4x4 matShadow;

struct HLSL_ShadowMapping_Pass_1_Pixel_Shader_PS_INPUT 
{
   float2 Texcoord  :        TEXCOORD0;
   float3 Normal    :        TEXCOORD1;         
   float3 View      :        TEXCOORD2;  
   float4 VPosLight :        TEXCOORD3;
   float4 UPosLight :        TEXCOORD4;
};

float filter_PCF2x2SOFT(float4 ShadowTexC, float4 VPosLight){
   float4 result = 0.0f;     
   
   ShadowTexC.xy /= ShadowTexC.w;
   
   float2 lerps = frac(fvSize * ShadowTexC);
  
   result.x = tex2D(ShadowMap, ShadowTexC + float2(0.0f, 0.0f)) + fvBias < VPosLight.z / VPosLight.w  ? 0.0f: 1.0f;
   result.y = tex2D(ShadowMap, ShadowTexC + float2(fvOffset, 0.0f)) + fvBias < VPosLight.z / VPosLight.w  ? 0.0f: 1.0f;
   result.z = tex2D(ShadowMap, ShadowTexC + float2(0.0f, fvOffset)) + fvBias < VPosLight.z / VPosLight.w  ? 0.0f: 1.0f;
   result.w = tex2D(ShadowMap, ShadowTexC + float2(fvOffset, fvOffset)) + fvBias < VPosLight.z / VPosLight.w  ? 0.0f: 1.0f;      
   
    
   float shadow = lerp(           lerp( result.x, result.y, lerps.x ),
                                  lerp( result.z, result.w, lerps.x ),
                                  lerps.y );                                  
   return shadow;  
};

float4 HLSL_ShadowMapping_Pass_1_Pixel_Shader_ps_main( HLSL_ShadowMapping_Pass_1_Pixel_Shader_PS_INPUT Input ) : COLOR0
{  
  float4 color = tex2D(HLSL_ShadowMapping_Pass_1_Pixel_Shader_baseMap, Input.Texcoord);
  //1. Ambient Term
  float4 ambient = (HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvAmbient * HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvMaterial.x + color.a);
  
  //2. Diffuse Term
  float3 L = normalize(HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvLightPosition - Input.View);   
  float4 diffuse = HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvDiffuse * HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvMaterial.y * max(0, dot(Input.Normal, L));
   
  //3. Specular Term
  float3 V = normalize(HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvViewPosition - Input.View);
  float3 H = normalize(L + V);
  float4 specular = HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvSpecular * HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvMaterial.z * pow(max(dot(Input.Normal,H),0),HLSL_ShadowMapping_Pass_1_Pixel_Shader_fvMaterial.w);
      
  // Shadow Stuff - Begin ////////////
  
  //2x2 Percentage closest Filtering
  float shadow = 1.0f;
  if(bvShadow){          
     shadow = filter_PCF2x2SOFT(Input.UPosLight, Input.VPosLight);  
  }
  // Shadow Stuff - End //////////////
  
  //4. Composition  
  float4 Final = HLSL_ShadowMapping_Pass_1_Pixel_Shader_fblend * saturate( ambient * color + (diffuse * color + specular) * shadow);   
  return Final;    
}



//--------------------------------------------------------------//
// ShadowMappingBump
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string HLSL_ShadowMappingBump_Pass_0_Model : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\Torus.3ds";

texture HLSL_ShadowMappingBump_Pass_0_ShadowMap : RenderColorTarget
<
   float2 RenderTargetDimensions = {512,512};
   string Format="D3DFMT_R32F";
   float  ClearDepth=1.000000;
   int    ClearColor=0;
>;
float4x4 HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_matLightViewProjection
<
   string UIName = "HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_matLightViewProjection";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
> = float4x4( 1.20, 0.00, 0.00, 0.00, 0.00, 2.41, 0.00, 36.21, 0.00, 0.00, 1.00, 149.15, 0.00, 0.00, 1.00, 150.00 );

struct HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
};

struct HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;  
   float2 Depth    : TEXCOORD0;   
};

HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_VS_OUTPUT HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_vs_main( HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_VS_INPUT Input )
{
   HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_VS_OUTPUT Output;
   
   Output.Position = mul(Input.Position, HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_matLightViewProjection);  
      
   Output.Depth.xy = Output.Position.zw;   
   
   return( Output );   
}




float4 HLSL_ShadowMappingBump_Pass_0_Pixel_Shader_ps_main(float2 Depth: TEXCOORD0) : COLOR
{        
      return Depth.x / Depth.y;
}




//--------------------------------------------------------------//
// Pass 1
//--------------------------------------------------------------//
string HLSL_ShadowMappingBump_Pass_1_Model : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\Torus.3ds";

float4x4 HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matLightViewProjection
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matLightViewProjection";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
> = float4x4( 1.20, 0.00, 0.00, 0.00, 0.00, 2.41, 0.00, 36.21, 0.00, 0.00, 1.00, 149.15, 0.00, 0.00, 1.00, 150.00 );
float4x4 HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matWorld : World;
float4x4 HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matWorldViewProjection : WorldViewProjection;
float4 HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_fvLightPosition
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_fvLightPosition";
   string UIWidget = "Direction";
   bool UIVisible =  true;
   float4 UIMin = float4( -10.00, -10.00, -10.00, -10.00 );
   float4 UIMax = float4( 10.00, 10.00, 10.00, 10.00 );
   bool Normalize =  false;
> = float4( 0.00, 0.00, -150.00, 1.00 );
float4 HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_fvViewPosition : ViewPosition;

struct HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   float2 Texcoord : TEXCOORD0;
   float3 Normal   : NORMAL0;
   float3 Binormal : BINORMAL0;
   float3 Tangent  : TANGENT0;
   
};

struct HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_VS_OUTPUT 
{
   float4 Position  :        POSITION0;
   float2 Texcoord  :        TEXCOORD0;
   float3 ViewDir   :        TEXCOORD1;
   float3 LightDir  :        TEXCOORD2;   
   float4 VPosLight :        TEXCOORD3; // ShadowMapping
   float4 UPosLight :        TEXCOORD4; // ShadowMapping
};

HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_VS_OUTPUT HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_vs_main( HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_VS_INPUT Input )
{
   HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_VS_OUTPUT Output = (HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_VS_OUTPUT) 0;
   
    // Output: Transformed Position
   Output.Position = mul(Input.Position, HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matWorldViewProjection);  
   
   // Output: Texture Coords
   Output.Texcoord = Input.Texcoord;   
   
   float4 WorldPosition = mul(Input.Position, HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matWorld);   
    
   float3 LightinViewSpaceDirection = normalize(HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_fvLightPosition - WorldPosition); 
   float3 CamerainViewSpaceDirection = normalize(HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_fvViewPosition - WorldPosition);
   
   float3 Normal   = normalize(mul(Input.Normal, HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matWorld));
   float3 Binormal = normalize(mul(Input.Binormal, HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matWorld));
   float3 Tangent  = normalize(mul(Input.Tangent, HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matWorld));   
   
   float3x3 WorldToTangent = float3x3( Tangent, Binormal, Normal );
   
   Output.LightDir = mul(LightinViewSpaceDirection, WorldToTangent);
   Output.ViewDir = mul(WorldToTangent, CamerainViewSpaceDirection);
      
   // Calculate LightProjection
   // Matrix to transform from object space to light space   
   Output.VPosLight = mul(WorldPosition, HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_matLightViewProjection);        
   Output.UPosLight.xyz = Output.VPosLight.xyz * float3(0.5f,-0.5f,0.5f) + Output.VPosLight.w * 0.5f;
   Output.UPosLight.w = Output.VPosLight.w;
   return( Output );
   
}



float4 HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvAmbient
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvAmbient";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.62, 0.62, 0.62, 0.00 );
float4 HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvDiffuse
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvDiffuse";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.73, 0.73, 0.73, 0.00 );
float4 HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvSpecular
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvSpecular";
   string UIWidget = "Color";
   bool UIVisible =  true;
> = float4( 0.97, 1.00, 0.73, 0.00 );
float4 HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvMaterial
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvMaterial";
   string UIWidget = "Direction";
   bool UIVisible =  false;
   float4 UIMin = float4( 0.00, 0.00, 0.00, 0.00 );
   float4 UIMax = float4( 1.00, 1.00, 1.00, 1.00 );
   bool Normalize =  false;
> = float4( 0.57, 0.90, 0.55, 8.59 );
float HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fblend
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fblend";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
> = float( 1.00 );
sampler2D HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_baseMap = sampler_state
{
   Texture = (base_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   MINFILTER = LINEAR;
   MAGFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
texture bump_Tex
<
   string ResourceName = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Textures\\FieldstoneBumpDOT3.tga";
>;
sampler2D bumpMap = sampler_state
{
   Texture = (bump_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   MINFILTER = LINEAR;
   MAGFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
sampler HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap = sampler_state
{
   Texture = (ShadowMap_Tex);
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
   MINFILTER = POINT;
   MIPFILTER = POINT;
   MAGFILTER = POINT;
};

float HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvBias
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvBias";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 0.01;
> = float( 0.00 );
float HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvSize
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvSize";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = -1.00;
   float UIMax = 0.00;
> = float( 512.00 );
float HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset";
   string UIWidget = "Numeric";
   bool UIVisible =  false;
   float UIMin = -1.00;
   float UIMax = 1.00;
> = float( 0.00 );
bool HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_bvShadow
<
   string UIName = "HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_bvShadow";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
> = bool( true );
float4x4 HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_matShadow;

struct HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_PS_INPUT 
{
   float2 Texcoord  :        TEXCOORD0;
   float3 ViewDir   :        TEXCOORD1;
   float3 LightDir  :        TEXCOORD2;   
   float4 VPosLight :        TEXCOORD3; // ShadowMapping
   float4 UPosLight :        TEXCOORD4; // ShadowMapping
};

float filter_PCF2x2(float4 ShadowTexC, float4 VPosLight){
   float4 result = 0.0f;     
   ShadowTexC.xy /= ShadowTexC.w;
     
   result.x = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap, ShadowTexC + float2(-HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset, -HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset));
   result.y = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap, ShadowTexC + float2(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset, -HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset));
   result.z = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap, ShadowTexC + float2(-HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset, HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset));
   result.w = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap, ShadowTexC + float2(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset, HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset));      
   
   float4 inlight = VPosLight.z / VPosLight.w < result + HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvBias ;     
   return dot(inlight, float4(0.25f,0.25f,0.25f,0.25f));   
};

float HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_filter_PCF2x2SOFT(float4 ShadowTexC, float4 VPosLight){
   float4 result = 0.0f;     
   
   ShadowTexC.xy /= ShadowTexC.w;
   
   float2 lerps = frac(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvSize * ShadowTexC);
  
   result.x = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap, ShadowTexC + float2(0.0f, 0.0f)) + HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvBias < VPosLight.z / VPosLight.w  ? 0.0f: 1.0f;
   result.y = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap, ShadowTexC + float2(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset, 0.0f)) + HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvBias < VPosLight.z / VPosLight.w  ? 0.0f: 1.0f;
   result.z = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap, ShadowTexC + float2(0.0f, HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset)) + HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvBias < VPosLight.z / VPosLight.w  ? 0.0f: 1.0f;
   result.w = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ShadowMap, ShadowTexC + float2(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset, HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvOffset)) + HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvBias < VPosLight.z / VPosLight.w  ? 0.0f: 1.0f;      
   
    
   float shadow = lerp(           lerp( result.x, result.y, lerps.x ),
                                  lerp( result.z, result.w, lerps.x ),
                                  lerps.y );                                  
   return shadow;  
};

float4 HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ps_main( HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_PS_INPUT Input ) : COLOR0
{  
  float4 color = tex2D(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_baseMap, Input.Texcoord);   
  // Shadow Stuff - Begin //////////////
  //2x2 Percentage closest Filtering
  float shadow = 1.0f;
  if(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_bvShadow){          
     shadow = HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_filter_PCF2x2SOFT(Input.UPosLight, Input.VPosLight);  
  }
  // Shadow Stuff - End //////////////
  
  float3 N = normalize( (tex2D(bumpMap, Input.Texcoord).xyz * 2.0f) - 1.0f);
  float3 NDotL = dot(N,Input.LightDir);
  
  float3 H = normalize(Input.LightDir + Input.ViewDir);
  float3 NDotH = dot(N,H);
  
  float4 lighting = lit(NDotL,NDotH,HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvMaterial.w);  
  // Bump Mapping - End
  
  //1. Ambient Term
  //float4 ambient = max(HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvMaterial.x, color.a) * HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvAmbient;  
  float4 ambient = (HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvAmbient * HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvMaterial.x + color.a);  
  //2. Diffuse Term
  float4 diffuse = (HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvDiffuse * HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvMaterial.y * lighting.y);
  //3. Specular Term
  float4 specular = (HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvSpecular * HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fvMaterial.z * lighting.z);
  //4. Composition     
  return HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_fblend * saturate( ambient * color + (diffuse * color + specular) * shadow);   
}



//--------------------------------------------------------------//
// Textured
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string HLSL_Textured_Pass_0_Model : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\Sphere.3ds";

float4x4 matViewProjection : ViewProjection;

struct HLSL_Textured_Pass_0_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   float2 Texcoord : TEXCOORD0;
   
};

struct HLSL_Textured_Pass_0_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;
   float2 Texcoord : TEXCOORD0;
   
};

HLSL_Textured_Pass_0_Vertex_Shader_VS_OUTPUT HLSL_Textured_Pass_0_Vertex_Shader_vs_main( HLSL_Textured_Pass_0_Vertex_Shader_VS_INPUT Input )
{
   HLSL_Textured_Pass_0_Vertex_Shader_VS_OUTPUT Output;

   Output.Position = mul( Input.Position, matViewProjection );
   Output.Texcoord = Input.Texcoord;

   return( Output );
   
}




float HLSL_Textured_Pass_0_Pixel_Shader_fblend
<
   string UIName = "HLSL_Textured_Pass_0_Pixel_Shader_fblend";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
> = float( 1.00 );
sampler2D HLSL_Textured_Pass_0_Pixel_Shader_baseMap = sampler_state
{
   Texture = (base_Tex);
   ADDRESSU = WRAP;
   ADDRESSV = WRAP;
   MINFILTER = LINEAR;
   MAGFILTER = LINEAR;
   MIPFILTER = LINEAR;
};

struct HLSL_Textured_Pass_0_Pixel_Shader_PS_INPUT 
{
   float2 Texcoord : TEXCOORD0;
   
};

float4 HLSL_Textured_Pass_0_Pixel_Shader_ps_main( HLSL_Textured_Pass_0_Pixel_Shader_PS_INPUT Input ) : COLOR0
{
   float4 color = tex2D( HLSL_Textured_Pass_0_Pixel_Shader_baseMap, Input.Texcoord );
   color.a = 0.0f;
   return color * HLSL_Textured_Pass_0_Pixel_Shader_fblend;      
}




//--------------------------------------------------------------//
// Glow
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string HLSL_Glow_Pass_0_Model : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\Torus.3ds";

texture renderTexture_Tex : RenderColorTarget
<
   float2 ViewportRatio={1.0,1.0};
   string Format="D3DFMT_A8R8G8B8";
   float  ClearDepth=1.000000;
   int    ClearColor=-16777216;
>;
float4x4 HLSL_Glow_Pass_0_Vertex_Shader_matViewProjection : ViewProjection;

struct HLSL_Glow_Pass_0_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;   
};

struct HLSL_Glow_Pass_0_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;   
};

HLSL_Glow_Pass_0_Vertex_Shader_VS_OUTPUT HLSL_Glow_Pass_0_Vertex_Shader_vs_main( HLSL_Glow_Pass_0_Vertex_Shader_VS_INPUT Input )
{
   HLSL_Glow_Pass_0_Vertex_Shader_VS_OUTPUT Output;

   Output.Position = mul( Input.Position, HLSL_Glow_Pass_0_Vertex_Shader_matViewProjection );
   
   Output.TexCoord = Input.TexCoord;
   
   return( Output );
   
}




texture noise_Tex
<
   string ResourceName = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Textures\\distortion.tga";
>;
sampler2D Texture0 = sampler_state
{
   Texture = (noise_Tex);
};

struct HLSL_Glow_Pass_0_Pixel_Shader_PS_INPUT 
{
   float2 TexCoord : TEXCOORD0;   
};


float4 HLSL_Glow_Pass_0_Pixel_Shader_ps_main(HLSL_Glow_Pass_0_Pixel_Shader_PS_INPUT input) : COLOR0
{   
   float4 color = tex2D(Texture0, input.TexCoord);
   return(color);   
}




//--------------------------------------------------------------//
// xAlpha
//--------------------------------------------------------------//
string HLSL_Glow_xAlpha_ScreenAlignedQuad : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\ScreenAlignedQuad.3ds";

texture glowTextureX_Tex : RenderColorTarget
<
   float2 RenderTargetDimensions = {512,512};
   string Format="D3DFMT_A8R8G8B8";
   float  ClearDepth=1.000000;
   int    ClearColor=-16777216;
>;
struct HLSL_Glow_xAlpha_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;
   
};

struct HLSL_Glow_xAlpha_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;
};

HLSL_Glow_xAlpha_Vertex_Shader_VS_OUTPUT HLSL_Glow_xAlpha_Vertex_Shader_vs_main( HLSL_Glow_xAlpha_Vertex_Shader_VS_INPUT Input )
{
   HLSL_Glow_xAlpha_Vertex_Shader_VS_OUTPUT Output;

   //utput.Position = mul( Input.Position, matViewProjection );
   Output.Position = float4 (Input.Position.x, Input.Position.y, 0.0f, 1.0f);
   
   Output.TexCoord = Input.TexCoord;
   
   return( Output );
   
}




sampler2D HLSL_Glow_xAlpha_Pixel_Shader_baseMap = sampler_state
{
   Texture = (renderTexture_Tex);
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
   MAGFILTER = LINEAR;
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
};

struct HLSL_Glow_xAlpha_Pixel_Shader_PS_INPUT 
{
   float2 TexCoord : TEXCOORD0;   
};

float4 HLSL_Glow_xAlpha_Pixel_Shader_ps_main(HLSL_Glow_xAlpha_Pixel_Shader_PS_INPUT input) : COLOR0
{   
   float4 color = tex2D(HLSL_Glow_xAlpha_Pixel_Shader_baseMap, input.TexCoord);
   if (color.a < 0.20f) color.a = 0.0f;
   return saturate(color * color.a);   
}




//--------------------------------------------------------------//
// BlurX
//--------------------------------------------------------------//
string HLSL_Glow_BlurX_ScreenAlignedQuad : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\ScreenAlignedQuad.3ds";

texture glowTextureXY_Tex : RenderColorTarget
<
   float2 RenderTargetDimensions = {512,512};
   string Format="D3DFMT_A8R8G8B8";
   float  ClearDepth=1.000000;
   int    ClearColor=-16777216;
>;
struct HLSL_Glow_BlurX_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;
   
};

struct HLSL_Glow_BlurX_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;
};

HLSL_Glow_BlurX_Vertex_Shader_VS_OUTPUT HLSL_Glow_BlurX_Vertex_Shader_vs_main( HLSL_Glow_BlurX_Vertex_Shader_VS_INPUT Input )
{
   HLSL_Glow_BlurX_Vertex_Shader_VS_OUTPUT Output;

   //Output.Position = mul( Input.Position, matViewProjection );
   Output.Position = float4 (Input.Position.x, Input.Position.y, 0.0f, 1.0f);
   
   Output.TexCoord = Input.TexCoord;
   
   return( Output );
   
}




sampler2D glowMap = sampler_state
{
   Texture = (glowTextureX_Tex);
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
};


struct HLSL_Glow_BlurX_Pixel_Shader_PS_INPUT 
{
   float2 TexCoord : TEXCOORD0;   
};

float4 HLSL_Glow_BlurX_Pixel_Shader_ps_main(HLSL_Glow_BlurX_Pixel_Shader_PS_INPUT input) : COLOR0
{   
  float4 color = float4(0.0f,0.0f,0.0f,0.0f);   
  float fvWeights[3] = {0.0122f,0.0546f,0.1598f};  
  //float fvWeights[7] = {0.0043f,0.0079f,0.0182f,0.0364f,0.0635f,0.0963f,0.1272f};
  
  for(int i = 0; i<3; i++){
      color += tex2D(glowMap, input.TexCoord + (float) (4-i) * float2(0.002f,0.0f) + float2(0.001f,0.001f)) * fvWeights[i];
      color += tex2D(glowMap, input.TexCoord - (float) (4-i) * float2(0.002f,0.0f) + float2(0.001f,0.001f)) * fvWeights[i];      
  }   
  color += (tex2D(glowMap, input.TexCoord + float2(0.002f,0.002f)) *  0.5468f) ;
  return color;         
}




//--------------------------------------------------------------//
// BlurY
//--------------------------------------------------------------//
string HLSL_Glow_BlurY_ScreenAlignedQuad : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\ScreenAlignedQuad.3ds";

texture HLSL_Glow_BlurY_glowTextureX : RenderColorTarget
<
   float2 RenderTargetDimensions = {512,512};
   string Format="D3DFMT_A8R8G8B8";
   float  ClearDepth=1.000000;
   int    ClearColor=-16777216;
>;
struct HLSL_Glow_BlurY_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;
   
};

struct HLSL_Glow_BlurY_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;
};

HLSL_Glow_BlurY_Vertex_Shader_VS_OUTPUT HLSL_Glow_BlurY_Vertex_Shader_vs_main( HLSL_Glow_BlurY_Vertex_Shader_VS_INPUT Input )
{
   HLSL_Glow_BlurY_Vertex_Shader_VS_OUTPUT Output;

   //Output.Position = mul( Input.Position, matViewProjection );
   Output.Position = float4 (Input.Position.x, Input.Position.y, 0.0f, 1.0f);
   
   Output.TexCoord = Input.TexCoord;
   
   return( Output );
   
}




sampler2D HLSL_Glow_BlurY_Pixel_Shader_glowMap = sampler_state
{
   Texture = (glowTextureXY_Tex);
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
};

struct HLSL_Glow_BlurY_Pixel_Shader_PS_INPUT 
{
   float2 TexCoord : TEXCOORD0;   
};

float4 HLSL_Glow_BlurY_Pixel_Shader_ps_main(HLSL_Glow_BlurY_Pixel_Shader_PS_INPUT input) : COLOR0
{   
  float4 color = float4(0.0f,0.0f,0.0f,0.0f);
  float fvWeights[3] = {0.0755f,0.0755f,0.1755};  
  //float fvWeights[7] = {0.0043f,0.0079f,0.0182f,0.0364f,0.0635f,0.0963f,0.1272f};
      
  for(int i = 0; i<3; i++){
     color += tex2D(HLSL_Glow_BlurY_Pixel_Shader_glowMap, input.TexCoord + (float) (4-i) * float2(0.0f, 0.002f) + float2(0.001f,0.001f)) * fvWeights[i];
     color += tex2D(HLSL_Glow_BlurY_Pixel_Shader_glowMap, input.TexCoord - (float) (4-i) * float2(0.0f, 0.002f) + float2(0.001f,0.001f)) * fvWeights[i];      
  }   
  color += (tex2D(HLSL_Glow_BlurY_Pixel_Shader_glowMap, input.TexCoord + float2(0.002f,0.002f)) * 0.5468f) ;//0.5468f //0.2924f
  return color;   
}
//--------------------------------------------------------------//
// Final
//--------------------------------------------------------------//
string HLSL_Glow_Final_ScreenAlignedQuad : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\ScreenAlignedQuad.3ds";

struct HLSL_Glow_Final_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;
};

struct HLSL_Glow_Final_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;
   float2 TexCoord : TEXCOORD0;   
};

HLSL_Glow_Final_Vertex_Shader_VS_OUTPUT HLSL_Glow_Final_Vertex_Shader_vs_main( HLSL_Glow_Final_Vertex_Shader_VS_INPUT Input )
{
   HLSL_Glow_Final_Vertex_Shader_VS_OUTPUT Output;

   //Output.Position = mul( Input.Position, matViewProjection );
   Output.Position = float4 (Input.Position.x, Input.Position.y, 0.0f, 1.0f);
   
   Output.TexCoord = Input.TexCoord;
   
   return( Output );
   
}




sampler2D HLSL_Glow_Final_Pixel_Shader_baseMap = sampler_state
{
   Texture = (renderTexture_Tex);
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
};
sampler2D HLSL_Glow_Final_Pixel_Shader_glowMap = sampler_state
{
   Texture = (glowTextureX_Tex);
   ADDRESSU = CLAMP;
   ADDRESSV = CLAMP;
   MAGFILTER = LINEAR;
   MINFILTER = LINEAR;
   MIPFILTER = LINEAR;
};

struct HLSL_Glow_Final_Pixel_Shader_PS_INPUT 
{
   float2 TexCoord : TEXCOORD0;   
};

float4 HLSL_Glow_Final_Pixel_Shader_ps_main(HLSL_Glow_Final_Pixel_Shader_PS_INPUT input) : COLOR0
{   
   float4 color = tex2D(HLSL_Glow_Final_Pixel_Shader_baseMap, input.TexCoord);   
   float4 glow =  tex2D(HLSL_Glow_Final_Pixel_Shader_glowMap, input.TexCoord);   
   return saturate(color + glow);   
   //return saturate(color * (1.0f - glow.a) + (glow * glow.a));
}




//--------------------------------------------------------------//
// Particles
//--------------------------------------------------------------//
//--------------------------------------------------------------//
// Pass 0
//--------------------------------------------------------------//
string HLSL_Particles_Pass_0_Model : ModelData = "C:\\Programme\\AMD\\RenderMonkey 1.71\\Examples\\Media\\Models\\QuadArray.3ds";

float4x4 matWorldView;
float4x4 HLSL_Particles_Pass_0_Vertex_Shader_matViewProjection : ViewProjection;
float4x4 HLSL_Particles_Pass_0_Vertex_Shader_matWorld : World;

struct HLSL_Particles_Pass_0_Vertex_Shader_VS_INPUT 
{
   float4 Position : POSITION0;
   
};

struct HLSL_Particles_Pass_0_Vertex_Shader_VS_OUTPUT 
{
   float4 Position : POSITION0;
   
};

HLSL_Particles_Pass_0_Vertex_Shader_VS_OUTPUT HLSL_Particles_Pass_0_Vertex_Shader_vs_main( HLSL_Particles_Pass_0_Vertex_Shader_VS_INPUT Input )
{
   HLSL_Particles_Pass_0_Vertex_Shader_VS_OUTPUT Output;
   
   float3 pos;
   // Billboard the quads.
   pos = Input.Position * (Input.Position.x * matWorldView[0] + Input.Position.y * matWorldView[1]);   
   
   float4 temp = mul(Input.Position, HLSL_Particles_Pass_0_Vertex_Shader_matWorld);
   
   Output.Position = mul(temp, HLSL_Particles_Pass_0_Vertex_Shader_matViewProjection );
   
   return( Output );
   
}




float HLSL_Particles_Pass_0_Pixel_Shader_fblend
<
   string UIName = "HLSL_Particles_Pass_0_Pixel_Shader_fblend";
   string UIWidget = "Numeric";
   bool UIVisible =  true;
   float UIMin = 0.00;
   float UIMax = 1.00;
> = float( 1.00 );

float4 HLSL_Particles_Pass_0_Pixel_Shader_ps_main() : COLOR
{   
   return( float4( HLSL_Particles_Pass_0_Pixel_Shader_fblend, HLSL_Particles_Pass_0_Pixel_Shader_fblend, HLSL_Particles_Pass_0_Pixel_Shader_fblend, 0.2f ) );   
}




//--------------------------------------------------------------//
// Technique Section for HLSL
//--------------------------------------------------------------//
technique TexturedPhong
{
   pass Pass_0
   {
      VertexShader = compile vs_2_0 HLSL_TexturedPhong_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_TexturedPhong_Pass_0_Pixel_Shader_ps_main();
   }

}

technique ShadowMapping
{
   pass Pass_0
   <
      string Script = "RenderColorTarget0 = ShadowMap_Tex;"
                      "ClearColor = (0, 0, 0, 0);"
                      "ClearDepth = 1.000000;";
   >
   {
      VertexShader = compile vs_2_0 HLSL_ShadowMapping_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_ShadowMapping_Pass_0_Pixel_Shader_ps_main();
   }

   pass Pass_1
   {
      VertexShader = compile vs_2_0 HLSL_ShadowMapping_Pass_1_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_ShadowMapping_Pass_1_Pixel_Shader_ps_main();
   }

}

technique ShadowMappingBump
{
   pass Pass_0
   <
      string Script = "RenderColorTarget0 = HLSL_ShadowMappingBump_Pass_0_ShadowMap;"
                      "ClearColor = (0, 0, 0, 0);"
                      "ClearDepth = 1.000000;";
   >
   {
      VertexShader = compile vs_2_0 HLSL_ShadowMappingBump_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_ShadowMappingBump_Pass_0_Pixel_Shader_ps_main();
   }

   pass Pass_1
   {
      VertexShader = compile vs_2_0 HLSL_ShadowMappingBump_Pass_1_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_ShadowMappingBump_Pass_1_Pixel_Shader_ps_main();
   }

}

technique Textured
{
   pass Pass_0
   {
      VertexShader = compile vs_2_0 HLSL_Textured_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_Textured_Pass_0_Pixel_Shader_ps_main();
   }

}

technique Glow
{
   pass Pass_0
   <
      string Script = "RenderColorTarget0 = renderTexture_Tex;"
                      "ClearColor = (0, 0, 0, 255);"
                      "ClearDepth = 1.000000;";
   >
   {
      VertexShader = compile vs_2_0 HLSL_Glow_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_Glow_Pass_0_Pixel_Shader_ps_main();
   }

   pass xAlpha
   <
      string Script = "RenderColorTarget0 = glowTextureX_Tex;"
                      "ClearColor = (0, 0, 0, 255);"
                      "ClearDepth = 1.000000;";
   >
   {
      CULLMODE = NONE;

      VertexShader = compile vs_2_0 HLSL_Glow_xAlpha_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_Glow_xAlpha_Pixel_Shader_ps_main();
   }

   pass BlurX
   <
      string Script = "RenderColorTarget0 = glowTextureXY_Tex;"
                      "ClearColor = (0, 0, 0, 255);"
                      "ClearDepth = 1.000000;";
   >
   {
      CULLMODE = NONE;

      VertexShader = compile vs_2_0 HLSL_Glow_BlurX_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_Glow_BlurX_Pixel_Shader_ps_main();
   }

   pass BlurY
   <
      string Script = "RenderColorTarget0 = HLSL_Glow_BlurY_glowTextureX;"
                      "ClearColor = (0, 0, 0, 255);"
                      "ClearDepth = 1.000000;";
   >
   {
      CULLMODE = NONE;

      VertexShader = compile vs_2_0 HLSL_Glow_BlurY_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_Glow_BlurY_Pixel_Shader_ps_main();
   }

   pass Final
   {
      CULLMODE = NONE;

      VertexShader = compile vs_2_0 HLSL_Glow_Final_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_Glow_Final_Pixel_Shader_ps_main();
   }

}

technique Particles
{
   pass Pass_0
   {
      ZWRITEENABLE = FALSE;

      VertexShader = compile vs_2_0 HLSL_Particles_Pass_0_Vertex_Shader_vs_main();
      PixelShader = compile ps_2_0 HLSL_Particles_Pass_0_Pixel_Shader_ps_main();
   }

}

